<template>
    <EditableTable
        :table-head="tableHead"
        :table-data="tableData"
        :editableItemId="editableItemId"
        :is-loading-prop="isLoading"
        @openEdit="openEdit"
    >
        <EditingOzonStorage
            :ozonStorageInfo="editableItem"
            @onClose="closeEdit"
        />
    </EditableTable>
</template>

<script>
import {mapState, mapActions} from 'vuex';

export default {
    name: "OZONStorage",
    data() {
        return {
            isLoading: false,
            tableHead: [
                {key: 'warehouse', label: 'Склад автозаказа'},
                {key: 'ozonWarehouse', label: 'Склад остатков Ozon'},
            ],
            editableItem: null,
        };
    },
    computed: {
        tableData() {
            const {ozonStorage} = this.constantsState;
            return ozonStorage.reduce((resultTableData, dataItem) => {
                try {
                    const {id, warehouse, ozon_warehouse} = dataItem;
                    const {name, temporary} = warehouse;
                    const ozonWarehouse = ozon_warehouse !== null
                        ? ozon_warehouse.name : '-';
                    resultTableData.push({
                        defaultItem: {...dataItem},
                        id,
                        warehouse: name,
                        ozonWarehouse,
                        temporary,
                    });
                    return resultTableData;
                } catch (e) {
                    console.error(e);
                    return resultTableData;
                }
            }, []);
        },
        editableItemId() {
            return this.editableItem ? this.editableItem.id : 0;
        },
        ...mapState({constantsState: 'constants'}),
    },
    methods: {
      openEdit(item) {
        const {defaultItem} = item;
        this.editableItem = {...defaultItem};
      },
      closeEdit({closeType, data}) {
        if (closeType) {
          this.changePreloaderState(true, 'Сохранение данных');
          this.editWarehouseCompliances({
            platform: 'ozon', item: this.editableItem, editedItem: data,
          })
            .then(response => {
              this.addToast({
                toastInfo: response.message,
                isVisibleToast: true,
                type: 'success',
              });
              this.editableItem = {};
              if (response.updateTables) {
                this.getWarehousesCompliancesBoth();
              }
            })
          .catch(response => {
            let message = '';
            if ('message' in response) message = response.message;
            this.addToast({
              toastInfo: message,
              isVisibleToast: true,
            });
          })
          .finally(() => this.changePreloaderState(false, ''))

        } else {
          this.editableItem = {};
        }
      },
      ...mapActions({
        getWarehousesCompliancesBoth: 'getWarehousesCompliancesBoth',
        editWarehouseCompliances: 'editWarehouseCompliances',
        addToast: 'toast/addToast',
      }),
    },
}
</script>
